#include <vcl.h>
#include <toolsapi.hpp>
#pragma hdrstop
USERES("map2dbgexp.res");
USEPACKAGE("vcl50.bpi");
USEUNIT("convert.cpp");
//---------------------------------------------------------------------------
#include "convert.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
int WINAPI DllEntryPoint(HINSTANCE, unsigned long, void*) {return 1;}



//=============================================================================
// MAP2DBGEXP - the BCB5 integrated version of the map2dbg utility
// It exists as a checkable menu item "Help|Generate ms-dbg"
// It installs a notifier. When it sees that non-code-insight compilation
// has finished, and the project executable has been rebuilt, it generates
// the dbg file.
// MsDbgExp is (c) 2000 Lucian Wischik
//=============================================================================








//=============================================================================
// GETCURRENTPROJECT
// Either there is no project group open, and just one project
// Or there is a project group open with its idea of the current project
// We use this information to figure out what project has just been built.
// so we know which one to mark
//=============================================================================
//
_di_IOTAProject __fastcall GetCurrentProject()
{ _di_IOTAModuleServices ms=NULL;
  HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&ms);
  if (FAILED(res)) return NULL;
  int foundproject=-1;
  for (int i=0; i<ms->ModuleCount; i++)
  { _di_IOTAModule m=ms->Modules[i];
    _di_IOTAProjectGroup pg=NULL;
    _di_IOTAProject p=NULL;
    res=m->QueryInterface(__uuidof(IOTAProjectGroup),(void**)&pg);
    if (SUCCEEDED(res)) return pg->GetActiveProject();
    res=m->QueryInterface(__uuidof(IOTAProject),(void**)&p);
    if (SUCCEEDED(res)) foundproject=i;
  }
  if (foundproject==-1) return NULL;
  _di_IOTAProject p=NULL;
  ms->Modules[foundproject]->QueryInterface(__uuidof(IOTAProject),(void**)&p);
  return p;
}
// GETPROJECTFROMFILENAME. Given c:\proj1.bpk we find its project
_di_IOTAProject __fastcall GetProjectFromFileName(AnsiString fn)
{ _di_IOTAModuleServices ms=NULL; HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&ms); if (FAILED(res)) return NULL;
  _di_IOTAModule m=ms->FindModule(fn); if (m==NULL) return NULL;
  _di_IOTAProject p=NULL; res=m->QueryInterface(__uuidof(IOTAProject),(void**)&p); if (FAILED(res)) return NULL;
  return p;
}











//=============================================================================
// TWatchIDENotifier -- a notifier that picks up AfterCompile events.
// As long as the compile succeeded, and wasn't due to code-insight,
// it fires an event.
//=============================================================================
//
typedef void __fastcall (__closure *TWatchNotifierEvent)(IOTANotifier *);
typedef void __fastcall (__closure *TWatchCancelEvent)(IOTANotifier *,bool &cancel);
class TWatchIDENotifier : public IOTAIDENotifier50
{
public:
  // IUnknown, IOTANotifier, IOTAIDENotifier, IOTAIDENotifier50
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTANotifier || riid==IID_IOTAIDENotifier || riid==IID_IOTAIDENotifier50) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  void __fastcall AfterSave(){} void __fastcall BeforeSave(){} void __fastcall Destroyed(){if (OnDestroy!=NULL) OnDestroy(this);}  void __fastcall Modified(){}
  void __fastcall BeforeCompile(const _di_IOTAProject Project, bool &cancel){}  void __fastcall AfterCompile(bool succeeded){}
  void __fastcall FileNotification(TOTAFileNotification fn,const AnsiString FileName,bool &cancel) {}
  //
  void __fastcall BeforeCompile(const _di_IOTAProject Project,bool IsCodeInsight, bool &cancel)
  { if (cancel || IsCodeInsight) return; OnBeforeCompile(this,cancel);
  }
  void __fastcall AfterCompile(bool succ,bool IsCodeInsight)
  { if (!succ || IsCodeInsight) return; OnAfterCompile(this);
  }
  //
  __fastcall TWatchIDENotifier(AnsiString aname,TWatchNotifierEvent AOnDestroy,TWatchCancelEvent AOnBeforeCompile,TWatchNotifierEvent AOnAfterCompile) : IOTAIDENotifier50(), ref(0), name(aname), OnDestroy(AOnDestroy), OnBeforeCompile(AOnBeforeCompile), OnAfterCompile(AOnAfterCompile), num(-1), s(NULL) {}
  void __fastcall AddNotifier()
  { RemoveNotifier();
    HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAServices),(void**)&s);  if (FAILED(res)) return;
    num=s->AddNotifier(this);
  }
  void __fastcall RemoveNotifier()
  { if (num!=-1 && s!=NULL) s->RemoveNotifier(num);
    num=-1; s=NULL;
  }
  long ref; AnsiString name; TWatchNotifierEvent OnDestroy; TWatchCancelEvent OnBeforeCompile; TWatchNotifierEvent OnAfterCompile; int num; _di_IOTAServices s;
};











//=============================================================================
// TMap2DbgExp -- an expert that plugs itself into the Help menu,
// installs a notifier, and waits. Upon notification of succesfull
// compilation, and as long as its menu option is checked, it marks the
// resultant executable as debug-stripped.
//=============================================================================
//
class TMap2DbgExp : public IOTAMenuWizard
{
public:
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTANotifier || riid==IID_IOTAWizard || riid==IID_IOTAMenuWizard) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  // IOTANotifier
  void __fastcall AfterSave() {}
  void __fastcall BeforeSave() {}
  void __fastcall Destroyed() {}
  void __fastcall Modified() {}
  // IOTAWizard
  AnsiString __fastcall GetIDString() {return "WISCHIK.MAP2DBGEXP";}
  AnsiString __fastcall GetName() {return "Map2dbg expert";}
  TWizardState __fastcall GetState() {TWizardState ws; ws << wsEnabled; if (stripping) ws << wsChecked; return ws;}
  void __fastcall Execute() {stripping=!stripping; Save();}
  // IOTAMenuWizard
  AnsiString __fastcall GetMenuText() {return "Generate ms-dbg";}
  // TOtaBrowseExpert
  __fastcall TMap2DbgExp() : IOTAMenuWizard(), ref(0)
  { Load();
    not=new TWatchIDENotifier("CompileWatcher",&NotDestroy,&NotBeforeCompile,&NotAfterCompile);
    not->AddRef();
    try {not->AddNotifier();}
    catch (...) {not->Release(); not=NULL;}
  }
  __fastcall ~TMap2DbgExp()
  { if (not!=NULL)
    { try {not->RemoveNotifier();}
      catch (...) {}
      not->Release();
      not=NULL;
    }
  }
  void __fastcall Load();
  void __fastcall Save();
  //
  void __fastcall NotDestroy(IOTANotifier *n)
  { if (not==NULL) return;
    try {not->RemoveNotifier();} catch (...) {}
    not->Release(); not=NULL;
  }
  void __fastcall NotBeforeCompile(IOTANotifier *n,bool &cancel);
  void __fastcall NotAfterCompile(IOTANotifier *n);
private:
  long ref; bool stripping; int feedback; TWatchIDENotifier *not;
  // feedback: 0=nothing, 1=beep, 2=message
};


void __fastcall TMap2DbgExp::Load()
{ stripping=true; feedback=2;
  LONG res; HKEY skey; DWORD val,valtype,valsize;
  res=RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Lu\\Map2dbg",0,KEY_ALL_ACCESS,&skey);
  if (res!=ERROR_SUCCESS) return;
  valsize=sizeof(val); res=RegQueryValueEx(skey,"Feedback",0,&valtype,(LPBYTE)&val,&valsize);
  if (res==ERROR_SUCCESS) {feedback=val; if (feedback<0 || feedback>2) feedback=2;}
  valsize=sizeof(val); res=RegQueryValueEx(skey,"Stripping",0,&valtype,(LPBYTE)&val,&valsize);
  if (res==ERROR_SUCCESS) {stripping = (val!=0);}
  RegCloseKey(skey);
}
void __fastcall TMap2DbgExp::Save()
{ LONG res;  HKEY skey;  DWORD val;  DWORD disp;
  res=RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Lu\\Map2dbg",
                     0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&skey,&disp);
  if (res!=ERROR_SUCCESS) return;
  val=feedback; RegSetValueEx(skey,"Feedback",0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  val=stripping?1:0; RegSetValueEx(skey,"Stripping",0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  RegCloseKey(skey);
}




void __fastcall TMap2DbgExp::NotBeforeCompile(IOTANotifier *not,bool &cancel)
{ if (!stripping) return; if (cancel) return;
  _di_IOTAProject p = GetCurrentProject(); if (p==NULL) return;
  _di_IOTAProjectOptions po = p->ProjectOptions;
  int map=po->Values["MapFile"]; // 0=off, 1=segments, 2=publics, 3=detailed
  //int i=po->Values["LinkShowMangle"]; bool mangle = (i!=0);
  if (map==2 || map==3) return; // publics or detailed are okay
  //
  _di_IOTAMessageServices40 ms=NULL; HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAMessageServices40),(void**)&ms); if (FAILED(res)) return;
  AnsiString msg="Ms-dbg needs a map file but it's currently ";
  if (map==0) msg=msg+"disabled"; else msg=msg+"segments-only.";
  msg=msg+"\r\nThe map-file will be turned on now.";
  //
  if (feedback==0) return;
  if (feedback==1) {ms->AddToolMessage(p->GetFileName(),msg,"ms-dbg",1,1);}
  if (feedback==2)
  { int res=Application->MessageBox(msg.c_str(),"Generate ms-dbg",MB_OKCANCEL);
    if (res==IDCANCEL) {cancel=true; return;}
  }
  po->Values["MapFile"]=2; po->ModifiedState=true;
}

AnsiString __fastcall RemoveTrailingSlash(AnsiString s)
{ if (s.SubString(s.Length(),1)=='\\') return s.SubString(1,s.Length()-1);
  else return s;
}

void __fastcall TMap2DbgExp::NotAfterCompile(IOTANotifier *not)
{ if (!stripping) return;
  _di_IOTAMessageServices40 ms=NULL; HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAMessageServices40),(void**)&ms); if (FAILED(res)) return;
  //
  _di_IOTAProject p = GetCurrentProject();
  _di_IOTAProjectOptions op = p->ProjectOptions;
  AnsiString fnp=p->GetFileName();
  AnsiString ext=op->GetOptionValue("AppFileExt");
  if (ext=="" || ext.LowerCase()=="lib") return;
  AnsiString dir = op->Values["OutputDir"];
  if (dir=="")
  { if (ext=="bpl")
    { AnsiString bcb=Application->ExeName; // "e:\borland\cbuilder5\bin\bcb.exe"
      bcb=ExtractFilePath(bcb);     // "e:\borland\cbuilder5\bin\"
      bcb=RemoveTrailingSlash(bcb); // "e:\borland\cbuilder5\bin"
      bcb=ExtractFilePath(bcb);     // "e:\borland\cbuilder5\"
      dir=bcb+"Projects\\bpl\\";    // "e:\borland\cbuilder5\projects\bpl"
    }
    else
    { dir=ExtractFilePath(fnp);     // "d:\myproj\"
    }
  }
  AnsiString exe=dir+ExtractFileName(fnp);  // "d:\myproj\myproj.bpr"
  exe = ChangeFileExt(exe,"."+ext);         // "d:\myproj\myproj.exe"
  // and luckily the map file always goes in the same directory as the exe
  //
  // First, we'll check whether the executable even has already been marked by us
  AnsiString err=""; IMAGE_DOS_HEADER idh; IMAGE_FILE_HEADER pfh;
  HANDLE hf=CreateFile(exe.c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL); DWORD red;
  if (hf==INVALID_HANDLE_VALUE) err="Failed to open file "+exe;
  if (err=="") {ReadFile(hf,&idh,sizeof(idh),&red,NULL); if (red!=sizeof(idh)) err="Failed to understand file "+exe;}
  if (err=="") {DWORD off=idh.e_lfanew+sizeof(DWORD); red=SetFilePointer(hf,off,NULL,FILE_BEGIN); if (red!=off) err+"Failed to understand file "+exe;}
  if (err=="") {ReadFile(hf,&pfh,sizeof(pfh),&red,NULL); if (red!=sizeof(pfh)) err="Failed to understand file "+exe;}
  bool already = ((pfh.Characteristics & IMAGE_FILE_DEBUG_STRIPPED)>0);
  if (hf!=INVALID_HANDLE_VALUE) CloseHandle(hf);
  if (err=="" && already) return; // it was already marked. Therefore not rebuilt. Therefore need do nothing
  //
  // It has been marked, so we have to change it.
  int num; if (err=="") num=convert(exe,err);
  if (err!="")
  { ms->AddToolMessage(p->GetFileName(),err,"ms-dbg",1,1);
    // and we'll also ensure that the message-view is open to see the error message
    TComponent *c=Application->FindComponent("EditorActionLists"); if (c==NULL) return;
    c=c->FindComponent("ecMessageView");
    TAction *a=dynamic_cast<TAction*>(c); if (a!=NULL) a->Execute();
    return;
  }
  // Success! How we report it depends on feedback level
  if (feedback==0) return;
  if (feedback==1) {MessageBeep(0); return;}
  if (feedback==2) {ms->AddToolMessage(p->GetFileName(),"Made .dbg file with "+AnsiString(num)+" symbols, and marked ."+ext+" as debug-stripped","ms-dbg",1,1);return;}
}



//---------------------------------------------------------------------------
namespace Map2dbgexp
{ void __fastcall PACKAGE Register()
  { RegisterPackageWizard(new TMap2DbgExp());
  }
}



